
;Custom Save File Dialog Test - DednDave - 9,2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;--------------------------------------------------------------------------------------------

IFNDEF   OFNOTIFY
OFNOTIFY STRUCT
  hdr      NMHDR <>
;   hwndFrom dd ?
;   idFrom   dd ?
;   code     dd ?
  lpOFN    dd ?
  pszFile  dd ?
OFNOTIFY ENDS
ENDIF

;--------------------------------------------------------------------------------------------

CBTProc      PROTO :UINT,:WPARAM,:LPARAM
OFNProc      PROTO :HWND,:UINT,:WPARAM,:LPARAM
HFree        PROTO :LPVOID

;--------------------------------------------------------------------------------------------

        .DATA

hWin         dd 0

szSaveAs     db 'Save As...',0
szExists     db 'File Already Exists',0
szAppend     db 'Append',0
szOverwrite  db 'Overwrite',0
szVerify     db 'Are You sure ?',0
szYes        db 'Yes',0
FileTypeStrs db 'Text Files',0,'*.txt',0,'All Files',0,'*.*',0,0

;--------------------------------------------

        .DATA?

hHeap        dd ?
hMbHook      dd ?
SaveAsFlag   dd ?

MbHookFlag   db ?

;--------------------------------------------------------------------------------------------

        .CODE

_main   PROC

        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx
        INVOKE  GetProcessHeap
        mov     hHeap,eax

        call    FSaveAs

        exit

_main   ENDP

;--------------------------------------------------------------------------------------------

FSaveAs PROC

;File Save As dialog

;OPENFILENAME STRUCT
; lStructSize       dd ?
; hwndOwner         dd ?
; hInstance         dd ?
; lpstrFilter       dd ?
; lpstrCustomFilter dd ?
; nMaxCustFilter    dd ?
; nFilterIndex      dd ?
; lpstrFile         dd ?
; nMaxFile          dd ?
; lpstrFileTitle    dd ?
; nMaxFileTitle     dd ?
; lpstrInitialDir   dd ?
; lpstrTitle        dd ?
; Flags             dd ?
; nFileOffset       dw ?
; nFileExtension    dw ?
; lpstrDefExt       dd ?
; lCustData         dd ?
; lpfnHook          dd ?
; lpTemplateName    dd ?

        call    FnAlloc
        mov dword ptr [eax],'xt.*'
        push    eax                                     ;HFree:hBlck
        mov     SaveAsFlag,ecx
        push    eax
        mov byte ptr [eax+4],'t'
        push    ecx                                     ;lpTemplateName
        push    OFNProc                                 ;lpfnHook
        push    ecx                                     ;lCustData
        push    offset FileTypeStrs+13                  ;lpstrDefExt - 'txt',0
        push    ecx                                     ;nFileOffset/nFileExtension
        push    OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_ENABLEHOOK or OFN_EXPLORER or OFN_PATHMUSTEXIST    ;Flags
        push    offset szSaveAs                         ;lpstrTitle
        push    ecx                                     ;lpstrInitialDir
        push    ecx                                     ;nMaxFileTitle
        push    ecx                                     ;lpstrFileTitle
        push    edx                                     ;nMaxFile
        push    eax                                     ;lpstrFile
        push    1                                       ;nFilterIndex
        push    ecx                                     ;nMaxCustFilter
        push    ecx                                     ;lpstrCustomFilter
        push    offset FileTypeStrs                     ;lpstrFilter
        push    ecx                                     ;hInstance
        push    ecx                                     ;hwndOwner
        push    76                                      ;lStructSize
        INVOKE  GetSaveFileName,esp
        add     esp,76                                  ;sizeof OPENFILENAME
        pop     edi
        cmp byte ptr [edi],0
        jz      FSave9

        INVOKE  MessageBox,0,edi,offset szSaveAs,MB_OK

FSave9: INVOKE  MessageBox,0,str$(SaveAsFlag),offset szSaveAs,MB_OK
        CALL    HFree
        ret

FSaveAs ENDP

;--------------------------------------------------------------------------------------------

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

OFNProc PROC    hDlg:HWND,uiMsg:UINT,wParam:WPARAM,lParam:LPARAM

;"Save As" dialog box customization

        cmp dword ptr [esp+8],WM_NOTIFY                          ;uiMsg
        mov     eax,[esp+16]                                     ;lParam
        jnz     OHook0

        cmp dword ptr [eax].OFNOTIFY.hdr.code,CDN_FILEOK
        jz      OHook1

OHook0: xor     eax,eax
        ret     16

OHook1: push    ebx
        mov     edx,[eax].OFNOTIFY.lpOFN
        push    edi
        movzx   ecx,word ptr [edx].OPENFILENAME.nFileExtension
        mov     ebx,[esp+12]                                     ;EBX = hDlg
        mov     edi,[edx].OPENFILENAME.lpstrFile                 ;EDI = offset path/file name
        jecxz   OHook5

;------------------------------------

;clean up file extension ambiguity

        add     ecx,edi
        cmp dword ptr [ecx],'txt'
        jnz     OHook5

        dec     ecx
        mov     edx,ecx
        jmp short OHook3

OHook2: movzx   eax,byte ptr [edx]
        cmp     al,'.'
        jz      OHook4

        cmp     al,'\'
        jz      OHook5

        cmp     al,':'
        jz      OHook5

        cmp     al,'/'
        jz      OHook5

OHook3: dec     edx
        cmp     edx,edi
        ja      OHook2

        jmp short OHook5

OHook4: mov     [ecx],ah

;------------------------------------

;test to see if file exists
;zero-length files are not considered to exist

;WIN32_FILE_ATTRIBUTE_DATA STRUCT
; dwFileAttributes dd ?
; ftCreationTime   FILETIME <>
;   dwLowDateTime    dd ?
;   dwHighDateTime   dd ?
; ftLastAccessTime FILETIME <>
;   dwLowDateTime    dd ?
;   dwHighDateTime   dd ?
; ftLastWriteTime  FILETIME <>
;   dwLowDateTime    dd ?
;   dwHighDateTime   dd ?
; nFileSizeHigh    dd ?
; nFileSizeLow     dd ?

;EDI = path/file name pointer

OHook5: xor     eax,eax
        push    eax
        push    eax
        sub     esp,sizeof WIN32_FILE_ATTRIBUTE_DATA-8
        INVOKE  GetFileAttributesEx,edi,eax,esp
        add     esp,sizeof WIN32_FILE_ATTRIBUTE_DATA-8
        pop     edx
        pop     eax
        or      eax,edx
        jz      OHook7

;------------------------------------

;message boxes with custom button text

        INVOKE  GetCurrentThreadId
        xor     edx,edx
        mov     MbHookFlag,dl
        INVOKE  SetWindowsHookEx,WH_CBT,CBTProc,edx,eax
        mov     hMbHook,eax
        INVOKE  MessageBox,ebx,offset szExists,offset szSaveAs,MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_DEFBUTTON3
        cmp     eax,IDNO
        jnz     OHook6

        mov     MbHookFlag,al
        INVOKE  MessageBox,ebx,offset szVerify,offset szOverwrite,MB_OKCANCEL or MB_ICONQUESTION or MB_DEFBUTTON2

OHook6: push    eax
        INVOKE  UnhookWindowsHookEx,hMbHook
        pop     eax
        cmp     al,6
        cmc
        sbb     al,ah
        shr     eax,1

;EAX: 0 = Overwrite, 1 = Cancel, 2 = Append

OHook7: cmp     al,1
        jz      OHook8

;------------------------------------

;exit - file accepted

        pop     edi
        mov     SaveAsFlag,eax
        pop     ebx
        jmp     OHook0

;------------------------------------

;exit - retry

OHook8: push    eax
        mov     [edi],ah
        INVOKE  SetWindowLong,ebx,DWLP_MSGRESULT,eax
        pop     eax
        pop     edi
        pop     ebx
        ret     16

OFNProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------------------------

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

CBTProc PROC    nCode:UINT,wParam:WPARAM,lParam:LPARAM

;hook to set Append/Overwrite/Yes MessageBox button strings

        cmp dword ptr [esp+4],HCBT_ACTIVATE    ;nCode
        jnz     CbtPr1

        push    esi
        push    IDOK
        mov     esi,[esp+16]                   ;wParam
        pop     eax
        mov     edx,offset szYes
        cmp     ah,MbHookFlag
        jnz     CbtPr0

        INVOKE  GetDlgItem,esi,IDYES
        INVOKE  SetWindowText,eax,offset szAppend
        push    IDNO
        mov     edx,offset szOverwrite
        pop     eax

CbtPr0: push    edx
        INVOKE  GetDlgItem,esi,eax
        push    eax
        CALL    SetWindowText
        pop     esi

CbtPr1: pop     edx
        push    hMbHook
        push    edx
        JMP     CallNextHookEx

CBTProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------------------------

FnAlloc PROC

;allocate temporary buffer for filenames

;  Returns: EAX = address of allocated block
;           ECX = 0
;           EDX = size of allocated block

        mov     edx,4096
        push    edx
        INVOKE  HeapAlloc,hHeap,HEAP_ZERO_MEMORY,edx
        xor     ecx,ecx
        pop     edx
        ret

FnAlloc ENDP

;--------------------------------------------------------------------------------------------

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

HFree   PROC    hBlck:LPVOID

;free heap allocation

        pop     edx
        push    NULL
        push    hHeap
        push    edx
        JMP     HeapFree

HFree   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------------------------

        END     _main

